/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_main.c
* Version      : Code Generator for RL78/G10 V1.05.02.03 [08 May 2018]
* Device(s)    : R5F10Y17
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2019/05/31
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_tau.h"
#include "r_cg_intp.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
volatile uint8_t g_SW_input = 0xFF;     /* XCb`̓tO           */
volatile uint8_t g_SW_timing;           /* XCb`̓^C~O       */
volatile uint8_t g_TM_count;            /* ^C}荞݃JE^       */
volatile uint8_t g_P_image;             /* o̓|[gC[W           */


volatile uint8_t g_tone_sel;            /* I                     */


volatile  uint16_t  g_timer_data;       /* PWMf[^iTDR00j       */
const uint16_t TDR00_DATA[8]=           /* Kp^C}JEgf[^   */
{
    9556,       /* Do:261.6Hz   */
    8513,       /* Re:293.7Hz   */
    7584,       /* Mi:329.6Hz   */
    7159,       /* Fa:349.2Hz   */
    6378,       /* So:392.0Hz   */
    5682,       /* Ra:440Hz     */
    5062,       /* Si:493.9Hz   */
    4778,       /* Do:523,3Hz   */
};

static void Tone_sel(void);             /* I                 */
static void Set_TDR_data(uint16_t);     /* TDRWX^ݒ菈          */
/* End user code. Do not edit comment generated here */

static void R_MAIN_UserInit(void);
/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    {
        uint16_t work;

        Tone_sel();                     /* I                 */

        while ( P13_bit.no7 == 0 )
        {                               /* XCb`̂҂   */
            NOP();
        }

        for ( work = 10000 ; work > 0 ; work-- )
        {
            NOP();
        }

        while (1U)
        {

            R_INTC0_Start();            /* XCb`荞݋         */
            STOP();                     /* ȓd̓[hŃXCb`҂   */
        /* STOP[h   */

/************************************************************************/
/*                                                                      */
/* XCb`ꂽꍇ̏                                         */
/*                                                                      */
/************************************************************************/

            while ( g_SW_input != 0xFF )
            {
                HALT();                 /* HALT[hŗ̂҂ */

            }

        }

    }
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    
    g_SW_input = 0xFF;                  /* XCb`̓NA           */
    g_TM_count = 0x00;                  /* ^C}荞݃JE^NA */

    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */

/*****************************************************************************
* Function Name: Tone_sel
* Description  : ̊֐P137,P02,P01̒[qɉĉݒ肷
* Arguments    : None
* Return Value : None
*****************************************************************************/
static void Tone_sel(void)
{
    uint8_t work;
    uint16_t tdr_data;

    if ( P13_bit.no7 == 1 )             /* P137̏ԃ`FbN           */
    {
        work = 0x04;                    /* SWIt̐ݒ               */
    }
    else
    {
        work = 0x00;                    /*  v_E̐ݒ          */
    }

    if ( P0_bit.no2 == 1 )              /* P02̏ԃ`FbN            */
    {
        work |= 0x02;                   /*  vAbv̐ݒ          */
    }

    if ( P0_bit.no1 == 1 )              /* P01̏ԃ`FbN            */
    {
        work |= 0x01;                   /*  vAbv̐ݒ          */
    }

    tdr_data = TDR00_DATA[work];        /* ݒpf[^ǂݏo     */
    g_timer_data = tdr_data;            /* f[^̕ۑ             */

    Set_TDR_data(tdr_data);             /* ^C}̎f[^ݒ       */
}


/*****************************************************************************
* Function Name: Set_TDR_dat
* Description  : ̊֐̓^C}TDRWX^ݒ肷
* Arguments    : f[^(tdr_data)
* Return Value : None
*****************************************************************************/
static void Set_TDR_data(uint16_t tdr_data)
{

    TDR01H = ( ( tdr_data - 1 ) >> 8 ); /* TDR01̏ʃf[^ݒ      */
    TDR01L = ( ( tdr_data - 1 ) & 0xFF ); /* ʃf[^ݒ             */
}

/* End user code. Do not edit comment generated here */
