/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2012, 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_tau_user.c
* Version      : Code Generator for RL78/G10 V1.05.02.03 [08 May 2018]
* Device(s)    : R5F10Y17
* Tool-Chain   : CCRL
* Description  : This file implements device driver for TAU module.
* Creation Date: 2019/05/31
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_tau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt r_tau0_channel1_interrupt(vect=INTTM01)
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
extern volatile uint8_t g_SW_input;     /* XCb`̓tO           */
extern volatile uint8_t g_TM_count;     /* ^C}荞݃JE^       */
extern volatile uint8_t g_SW_timing;    /* XCb`̓^C~O       */
extern volatile uint8_t g_P_image;      /* o̓|[gC[W           */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_tau0_channel1_interrupt
* Description  : This function INTTM01 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel1_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    
    P0 = g_P_image;                     /* |[go͐ݒ               */
    if ( g_P_image == 0x01 )            /* ~H                 */
    {                                   /* ~̏ꍇ               */
        R_TAU0_Channel1_Stop();         /* ^C}~               */
        g_SW_input = 0xFF;              /* XCb`~Ԃɐݒ     */
    }
    else
    {                                   /* p̏ꍇ               */
        if ( ( g_SW_input & 0x07 ) == 0x07 )    /* XCb`̏ԊmF   */
        {                               /* XCb`ꂽ           */
            g_P_image = 0x01;           /* ̃^C~OŔ~     */
        }
        else
        {                               /* XCb`͉Ă       */
            g_P_image ^= 0b00011000;    /* ̏o͂𔽓]         */

            g_SW_timing--;              /* ^C~OJEg         */
            if ( g_SW_timing == 0 )
            {                           /* XCb`mF^C~O       */
                g_SW_timing = SW_TIMING;/* SW`FbN^C~Oݒ */

                g_SW_input <<= 1;       /* XCb`͂̏           */
                if ( P13_bit.no7 == 1 )
                {
                    g_SW_input++;       /* XCb`ItԂݒ       */
                }
            }
        }
    }

    
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
